!This program cross correlated PART of or all of an event window with another
program fraccross3
  use sep
  implicit none
  integer                               :: n1,n2,ni1,ni2,nj1,nj2
  real                                  ::wait,o1,d1,o2,d2,oi1,oi2,di1,di2,oj1,oj2,dj1,dj2,quit
  integer                               :: i1,m, tt,i2,shift,iq,nn,mm,leave
  real, allocatable, dimension(:,:)     :: W,D, C,L,Dn1,Dn2,Dn
  real, allocatable, dimension(:)       ::  Ln

! W=master event window, begins after the "wait"
!D= any other event
 call sep_init()
  
  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

call from_param("wait", wait) !how much to wait before the reflection in "time"
call from_param("quit", quit)

 shift=wait*2*n1 !convert the time wait to samples
 leave=quit*2*n1
 
 ! nj1=n1-shift+1    !the new event window will begin at the shift value
  nj1=leave-shift+1
 
  allocate( D(n1,n2), W(n1,n2) , C(n1,n2), Ln(n2), Dn(n1,n2), Dn1(n1,n2), Dn2(n1,n2), L(nj1,n2))

  call sep_read(W) !standard input, master
  L=0.
  do mm=1,n2
 L(1:nj1,mm)=W(shift:leave,mm) !create the master event window starting from just before the reflection
  end do
  
  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  call sep_read(D,"aux")

 C=0. !set to zero to be safe

Ln=1./sqrt(MAX(1.0e-20,SUM(L**2,1))) !multiplier to normalize L

	do i1=1,n1

	Dn1(i1,:)=1./sqrt(MAX(1.0e-20,SUM(D(i1,:)**2,1))) !multiplier to normalize D, length is the length of the master reflection window
	Dn2(i2,:)=1./sqrt(MAX(1.0e-20,SUM(D(i1+nj1,:)**2,1)))
	Dn(i1,:)= Dn2(i1,:)-Dn1(i1,:)
	C(i1,:) = SUM(D(i1:i1+nj1,:)*L(:,:),1)*Ln*Dn(i1,:)
	end do

call sep_write(C)

call sep_close()
end program
