! This program increases the sampling density of a data file.
program fracsamp

  use sep

  implicit none

  include "fftw3.f"

  integer                             :: n1, n1i, n2, i, j, ratio
  real                                :: o1, d1, d1i, o2, d2

  complex, dimension(:), allocatable     :: in1, out1, in1i, out1i
  real,  dimension(:,:), allocatable     :: a, ia

  integer*8 plan1f
  integer*8 plan1b

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  call from_param("ratio", ratio)
 
if(ratio.LE.0) call erexit("ratio value is not valid") !just making sure you don't divide by zero or a negative number

  n1i = (n1-1)*ratio+1
  d1i = d1/ratio

  call to_history("n1", n1i)
  call to_history("o1", o1)
  call to_history("d1", d1i)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  ! Allocation
  allocate( a(n1,n2), ia(n1i,n2))
  allocate( in1(n1), out1(n1))
  allocate( in1i(n1i), out1i(n1i))

! Making sure no pre-existing saved values
  a = 0.
  ia = 0.
  in1 = 0.
  out1 = 0.
  in1i = 0.
  out1i = 0.

  call sep_read(a)


 !Initialization step, not actual fft

  call sfftw_plan_dft_1d(plan1f,n1      ,in1,out1,FFTW_FORWARD,FFTW_MEASURE)
  call sfftw_plan_dft_1d(plan1b,n1i     ,out1i,in1i,FFTW_BACKWARD,FFTW_MEASURE)

  do j=1,n2
    in1 = a(:,j) !in1=the desired input file
    call sfftw_execute_dft(plan1f, in1, out1)  !perform fft of a
    out1i(1:n1/2+1) = out1(1:n1/2+1) 
    out1i(n1i-n1/2+2:n1i) = out1(n1/2+2:n1)
    call sfftw_execute_dft(plan1b, out1i, in1i)
    ia(:,j) = 2*in1i*sqrt(1.*ratio/n1/n1i) !adjust the amplitudes so that I compensate for what the fftw does.
  end do
      

  call sep_write(ia) !write the padded file

  call sep_close()

end program
