! this is a program that applies a shift to a "waveform". The shift is the difference in location between the maximum of a master peak and the peak of the event in this file.
program Shifting
  use sep
  implicit none
  !! Type declarations
  integer                               :: n1,n2
  real                                  :: o1,d1,o2,d2
  integer                               :: yy
  real, allocatable, dimension(:,:)     :: input, output
  integer                               :: shift

  call sep_init()

  ! Read and write to History
  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

!  call from_aux("aux", "n1", n1)

  call from_param("shift", shift)

  if(abs(shift)>=n1) call erexit("shift is larger than n1")

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  allocate( input(n1,n2), output(n1,n2) )

  ! Read the data
  call sep_read(input)

  if(shift>=0) then
    do yy=1,n1-shift
      output(yy,:) = input(yy+shift,:)
    enddo
  else
    do yy=1-shift,n1
      output(yy,:) = input(yy+shift,:)
    enddo
! uu = yy+shift
! lbuu = lbyy + shift => 1
! ubuu = ubyy + shift => n1+shift
!    do yy=1,n1+shift
!      output(yy-shift,:) = input(yy,:)
!    enddo
  endif

  ! Write the data
  call sep_write(output)

  call sep_close()

end program
